{- Julien Cohen 2010 -}
{- Some code in this file comes from RefacUtils.hs by Simon Thompson's group at Univ. of Kent. -}


module RefacAddDeclIntoComment(f) where

import Prelude hiding (putStrLn)
import System.IO.Unsafe
import AbstractIO (putStrLn)
import Maybe
import List  
import TypeCheck
import RefacUtils hiding (renamePN)
import RefacLocUtils

f args
 = do let fileName  = args!!0
          newName   = args!!1            
          row       = read (args!!2)::Int
          col       = read (args!!3)::Int
      modName <- fileNameToModName fileName
      AbstractIO.putStrLn $ show modName
      (inscps, exps, mod,tokList) <- parseSourceFile fileName 
      
      let pnt       = locToPNT fileName (row, col) mod   
          defineMod = if isTopLevelPN (pNTtoPN pnt)
                           then (fromJust (hasModName pnt))
                           else modName
      
      unless (pnt /= defaultPNT)  $ error "Invalid cursor position" 
      unless (defineMod == modName ) ( error ("This identifier is defined in module " ++ modNameToStr defineMod ++ ", please do refactoring in that module!"))
      do (mod',((tokList',modified),_))<-doRenaming pnt newName modName mod inscps exps ((tokList,unmodified),fileName)
         writeRefactoredFiles False [((fileName,modified), (tokList',mod'))]


doRenaming oldPNT@(PNT oldPN Value loc) newName modName mod inscps exps env 
 = runStateT (applyTP (once_buTP (failTP `adhocTP` renameInMod)) mod) env
   where 
     
     renameInMod (mod::HsModuleP)
        |isDeclaredIn oldPN mod = renameTopLevelVarName oldPNT newName modName inscps exps mod True True
     renameInMod mod=mzero

renameTopLevelVarName oldPNT@(PNT oldPN _ _) newName modName inscps exps mod existChecking exportChecking
  = do  renamePN oldPN  Nothing newName True mod 


renamePN::((MonadState (([PosToken], Bool), t1) m),Term t)
           =>PName               -- ^ The identifier to be renamed.
             ->Maybe ModuleName  -- ^ The qualifier
             ->String            -- ^ The new name 
             ->Bool              -- ^ True means modifying the token stream as well.
             ->t                 -- ^ The syntax phrase
             ->m t  

renamePN oldPN qualifier newName updateToks t
  = applyTP (full_tdTP (adhocTP idTP rename)) t
  where
    rename  pnt@(PNT pn ty (N (Just (SrcLoc fileName c  row col))))
     | (pn ==oldPN) && (srcLoc oldPN == srcLoc pn)
     = do ((toks,_),others)<-get                           
          let toks'=replaceToks toks (row,col) (row,col) [mkToken Varid  (row,col) ((render.ppi) (replaceName pn  newName))]
          put ((toks', modified),others)
          return (PNT (replaceName pn newName) ty (N (Just (SrcLoc fileName c  row col))))
           
      where 
        replaceName = if isJust qualifier && canBeQualified pnt t 
                        then replaceNameInPN qualifier
                        else replaceNameInPN Nothing       
    rename x = return x 
 